<?php

namespace Teknisa\MAN\Controllers;


use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DTO\Response\Notification;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities\Query;
use Teknisa\MAN\Utilities;

class CadECF extends Crud {
    
	protected $dataSourceName = 'vnd59000_cadECF';
	protected $parameterBagColumns;
	protected $connection;
    
    public function __construct ($dataSourceManager,$entityManager, $util,$connection) {
        $this->entityManager = $entityManager;
        $this->util = $util;
        $this->connection = $connection;
        parent::__construct($dataSourceManager);
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $row = $dataSet->getRows();
            $param = array(
                ':NRSERIE' => $row[0]['NRSERIE']
                
            );
            $paramFilial = array(
                ':NRSERIE' => $row[0]['NRSERIE'],
                ':CDFILIAL' => $row[0]['CDFILIAL']
            );
            $result = $this->entityManager->getConnection()->fetchAll(Query::GET_ECF, $param);
            $resultFilial = $this->entityManager->getConnection()->fetchAll(Query::GET_ECF_FILIAL, $paramFilial);
            if (!$row[0]['__is_new'] && ($row[0]["NRSERIE"] == $row[0]["NRSERIEORIGIN"])){
                $dataSet->setDataSourceName($this->dataSourceName);
                $persistedRows = $this->dataSourceManager->persist($dataSet);
                $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
            }else if(count($resultFilial) > 0){
                throw new \Exception("Nº Série já cadastrado.");
            }
            else if((count($result) > 0) && (count($resultFilial) == 0)){
                throw new \Exception("Nº Série já cadastrado em outra Unidade.");
            }
            else if(count($result) == 0){
                $dataSet->setDataSourceName($this->dataSourceName);
                $persistedRows = $this->dataSourceManager->persist($dataSet);
                $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
            }
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function delete(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $deletedRows = $this->dataSourceManager->delete($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $deletedRows));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
}